import java.net.*;
import java.io.*;


class ThreadServerConnect extends Thread{		
protected Host host;
public ThreadServerConnect(Host host)
	{
	this.host=host;
	start();
	}
	
public void run()
	{
  Socket socket;
	for(;;)
		try{
	  socket=new Socket(host.address,host.port);
	  int i=Server.tab.connect(socket); 
	  Server.log(toString()+", table updated\n"+Server.tab);
	  new ThreadSocket(i); 
	  return;
	  } //try
	  catch(DuplicateKeyException ecc)
	  { Server.log(toString()+", already connected"); }
	  catch(Exception ecc)
	  {
		Server.log(toString()+", fail, retrying later");
	  try{sleep(30000);}catch(Exception ecc2){}	//30sec
		}	
	}
	
public String toString()
	{return	getName()+" connecting to "+host;}	
}



class ThreadServerListen extends Thread{
public ThreadServerListen()
	{start();}
public void run()
	{ServerSocket ssocket;
	try{
	ssocket=new ServerSocket(Server.tab.getLocalPort(),5);
	Server.log(toString()+", listening to servers on port "+
		          ssocket.getLocalPort());
	} //try	          	
	catch(Exception ecc){Server.log("Exception: "+ecc);return;}		  
	for(;;)
	  try
	  {
	  Socket socket=ssocket.accept();
    Server.log(toString()+", get connection");
  	int i=Server.tab.connect(socket); 
	  Server.log(toString()+", table updated\n"+Server.tab);
	  new ThreadSocket(i); 
	  } 
	  catch(DuplicateKeyException ecc)
	  {Server.log(toString()+", already connected"); }
	  catch(Exception ecc)
	  {Server.log("Exception: "+ecc);}		  
	}  
public String toString()
	{return	getName();}	
}

	
public class Server{
public static ServerTable tab;
public static WantedTable tab_rich;
protected int client_port;
public Server(File cfg)
	{
	log("Main starting "+cfg.getName());
	BufferedReader input;
	String line;
	try{
	input=new BufferedReader(new FileReader(cfg));
	client_port=Integer.parseInt(input.readLine());
	int server_port=Integer.parseInt(input.readLine());
        line=input.readLine();   //archive_dir
	//Server.tab vicini (vuota!!)
	tab=new ServerTable(server_port);
  //Server.tab file richiesti (vuota)
	tab_rich=new WantedTable(line);
  } //try
	catch(Exception ecc){log("Exception: "+ecc);return;}	
	//lancio un thread che cerca di connettersi con ogni vicino
	for(;;)
		try{
		line=input.readLine();
	  if(line==null) break;
	  Host host=new Host(
	    InetAddress.getByName(line.substring(0,line.indexOf(' '))),
	    Integer.parseInt(line.substring(line.lastIndexOf(' ')+1))
	    );
		new ThreadServerConnect(host);
		}
		catch(Exception ecc){log("Exception: "+ecc);}	
	//...e uno che ascolta se qualche vicino vuole connettersi
	new ThreadServerListen();
	//attesa di connessione dei clients
	//crea un ThreadClientService per ogni richiesta
	DatagramSocket udp_socket;
	try{
	udp_socket=new DatagramSocket(client_port);
	log("Main listening to clients on port "+
		  udp_socket.getLocalPort());
	log("Archive directory is "+tab_rich.getArchiveDir());
	}  //try
	catch(Exception ecc){log("Exception: "+ecc);return;}	
	for(;;)
		try{
		DatagramPacket packet=new DatagramPacket(new byte[256],256);
    udp_socket.receive(packet);
		String nomefile=new String(packet.getData());
		nomefile=nomefile.trim();
		new ThreadClient(nomefile,new Host(packet.getAddress(),packet.getPort()));	
		}//try
	  catch(Exception ecc){log("Exception: "+ecc);}
	}
public static void log(String comment)
	{System.out.println(comment);}
	
/***************************************/
public static void main(String[] arg)	
	{
	new Server(new File(arg[0])); 
	}
/***************************************/
}	
		