import java.net.*;
import java.io.*;

class Entry{
public Host host;
public int local_port;
public ObjectInputStream is;
public ObjectOutputStream os;
public Entry(Host host,int local_port,
	           ObjectInputStream in,ObjectOutputStream out)
	{this.host=host;
	this.local_port=local_port;
	is=in;
	os=out;
	}
}	



class ServerTable extends java.util.Vector{
protected int local_port;
public ServerTable(int local_port)
	{this.local_port=local_port;}
public int getLocalPort()
	{return local_port;}
public synchronized int connect(Socket socket)
throws Exception
	{
	ObjectOutputStream output=new ObjectOutputStream(socket.getOutputStream());
 	output.flush();
	ObjectInputStream input=new ObjectInputStream(socket.getInputStream());
	output.writeInt(local_port);
	output.flush();
	int peer_port=input.readInt();
	InetAddress ip=socket.getInetAddress();
	int i;
	for(i=0;i<size();i++)
		if(getHost(i).address.equals(ip) && 
			 getLocalPort(i)==peer_port) throw new DuplicateKeyException();
	addElement(new Entry(new Host(ip,socket.getPort()),peer_port,input,output));    
	return size()-1; 	
	}
public Host getHost(int i)
	{return ((Entry)elementAt(i)).host;}
public int getLocalPort(int i)
	{return ((Entry)elementAt(i)).local_port;}
public ObjectInputStream getObjectInputStream(int i)
	{return ((Entry)elementAt(i)).is;}
public ObjectOutputStream getObjectOutputStream(int i)
	{return ((Entry)elementAt(i)).os;}
public String toString()
	{int i,size;
	size=size();
	String s="  This server is connected to "+size+" servers";
	for(i=0;i<size;i++)
		s+="\n  ["+i+"] "+getHost(i)+" (listens on "+getLocalPort(i)+")";
	return s;		       	
	}
}
	