import java.net.*;
import java.io.*;

class ThreadClient extends Thread{
protected String nomefile;
protected Host client;
public ThreadClient(String nomefile,Host client)
	{
  this.nomefile=nomefile;
  this.client=client;
  start();	
	}
public void run()
	{
	Server.log(toString()+", searching "+nomefile);
	File filerichiesto=new File(Server.tab_rich.getArchiveDir(),nomefile);
	if(filerichiesto.exists()) 
		{
		Server.log(toString()+", file found");
	  sendFile(filerichiesto);
		}
	else
	if(Server.tab.size()==0)
		{
		Server.log(toString()+", file not found");
	  sendFile((File)null);
		}
	else
		{
		//controlla che il file non sia gi in ricerca
		ServerSocket ssocket;
		Socket sockdatain;
		Host host;
		try{
		ssocket=new ServerSocket(0,0);
		host=new Host(InetAddress.getLocalHost(),ssocket.getLocalPort());
		}
		catch(Exception ecc){Server.log("Exception: "+ecc);return;}
		try{
		Server.tab_rich.addEntry(nomefile, Server.tab.size(),ssocket);
		}
		catch(DuplicateKeyException ecc)
			{
		  Server.log(toString()+", file locked by another client");
		  sendFile((File)null);
		  return;
		  }  //catch
		// propaga richiesta a tutti i vicini
		int i;
		for (i=0; i<Server.tab.size(); i++) 
		  sendMessage(nomefile,host,Server.tab.getObjectOutputStream(i));
		Server.log(Server.tab_rich.toString());
		Server.log(toString()+", waiting for response...");
		try{
		ssocket.setSoTimeout(60000);
    sockdatain=ssocket.accept();	
		ssocket.close();
		}
		catch(InterruptedIOException ecc)     //timeout
      {Server.log(toString()+", nobody responding");
      Server.tab_rich.fileFound(nomefile);  //cancella entry		
		  try{ssocket.close();} catch(Exception ecc2){}
	    sendFile((File)null);
		  return;
		  }		
		catch(Exception ecc)   //file non trovato
		  {Server.log(toString()+", file not found by others");
      sendFile((File)null);
		  return;
		  }
		//file trovato
		Server.log(toString()+", file found by others");
    sendFile(sockdatain);
	  } //else
	}  //run
protected void sendMessage(String nomefile,Host host,ObjectOutputStream output)
	{
	try{
	synchronized(output) {
	output.writeObject(nomefile);
	output.writeLong(-1);   //richiesta
	output.writeObject(host);  
	output.flush();
	}}  //try
	catch (Exception ecc)    			   	
	{Server.log("Exception: " +ecc);	 	}
	}		
protected	void sendFile(File file)
	{
	try{
	Socket socket_cl=new Socket(client.address,client.port); 
	OutputStream output=socket_cl.getOutputStream();
	if(file==null) {socket_cl.close();return;}
	InputStream input=new FileInputStream(file);	
	int nread;
  byte[] buffer=new byte[4096];
  while((nread=input.read(buffer))>0)
    output.write(buffer,0,nread);
  socket_cl.close();	
	}  //try
	catch (Exception ecc)    			   	
	{Server.log("Client not responding: " +ecc);	 	}
	}		
protected	void sendFile(Socket socket_sorg)
	{
	try{
	Socket socket_cl=new Socket(client.address,client.port); 
	OutputStream output=socket_cl.getOutputStream();
	InputStream input=socket_sorg.getInputStream();	
	int nread;
  byte[] buffer=new byte[4096];
  while((nread=input.read(buffer))>0)
    output.write(buffer,0,nread);
  socket_cl.close();
  socket_sorg.close();	
	}  //try
	catch (Exception ecc)    			   	
	{Server.log("Client not responding: " +ecc);	 	}
	}		

public String toString()
	{return getName()+" serving client "+ client;}	

}