import java.io.*;
import java.net.*;	
import java.util.*;

class ThreadSimilClient extends Thread{
protected int da_chi;
protected String nomefile;
protected Host host_dest;
public ThreadSimilClient(String nomefile, int da_chi,Host host_dest)
	{
	this.da_chi=da_chi;
	this.nomefile=nomefile;
	this.host_dest=host_dest;
  start();
	}
public void run()
	{
	Server.log(toString()+", searching "+nomefile);
	File filerichiesto=new File(Server.tab_rich.getArchiveDir(),nomefile);
	if(filerichiesto.exists()) 
		{
		Server.log(toString()+", file found");
	  sendMessage(nomefile,1,null,Server.tab.getObjectOutputStream(da_chi));
	  sendFile(filerichiesto);
		}
	else
	if(Server.tab.size()==1)
		{
		Server.log(toString()+", file not found");
	  sendMessage(nomefile,0,null,Server.tab.getObjectOutputStream(da_chi));
	  }
	else
		{
		//controlla che il file non sia gi in ricerca
  	ServerSocket ssocket;
		Socket sockdatain;
		Host host;
		try{
		ssocket=new ServerSocket(0,0);
		host=new Host(InetAddress.getLocalHost(),ssocket.getLocalPort());
		}
		catch(Exception ecc){Server.log("Exception: "+ecc);return;}
		try{
		Server.tab_rich.addEntry(nomefile, Server.tab.size()-1,ssocket);
		}
		catch(DuplicateKeyException ecc)
			{
		  Server.log(toString()+", file ignored");
		  sendMessage(nomefile,0,null,Server.tab.getObjectOutputStream(da_chi));
	    return;
		  }  //catch
		//propaga richiesta a tutti i vicini, escluso il mandante
		int i;
		for (i=0; i<Server.tab.size(); i++) 
		  if(i!=da_chi) sendMessage(nomefile,-1,host,Server.tab.getObjectOutputStream(i));
		Server.log(Server.tab_rich.toString());
		Server.log(toString()+", waiting for response...");
		try{
		ssocket.setSoTimeout(60000);
    sockdatain=ssocket.accept();	
		ssocket.close();
		}
		catch(InterruptedIOException ecc)  //timeout
      {Server.log(toString()+", nobody responding");
      Server.tab_rich.fileFound(nomefile);  //cancella entry		
		  try{ssocket.close();} catch(Exception ecc2){}
	    sendMessage(nomefile,0,null,Server.tab.getObjectOutputStream(da_chi));
	    return;
		  }		
		catch(Exception ecc)   //file non trovato
		  {Server.log(toString()+", file not found by others");
      sendMessage(nomefile,0,null,Server.tab.getObjectOutputStream(da_chi));
	    return;
		  }
		//file trovato
		Server.log(toString()+", file found by others");
    sendMessage(nomefile,1,null,Server.tab.getObjectOutputStream(da_chi));
	  sendFile(sockdatain);
	  } //else
	}  //run
protected void sendMessage(String nomefile,long code,Host host,ObjectOutputStream output)
	{
	try{
	synchronized(output) {
	output.writeObject(nomefile);
	output.writeLong(code);   //richiesta
	if(code==-1) output.writeObject(host);   //a chi eventualmente rimandare il file
	output.flush();
	}}  //try
	catch (Exception ecc)    			   	
	{Server.log("Exception: " +ecc);	 	}
	}		
protected	void sendFile(File file)
	{
	Socket socket_dest;
	try{
	socket_dest=new Socket(host_dest.address,host_dest.port); 
	//socket_dest.setSoTimeout(20000);
	OutputStream output=socket_dest.getOutputStream();
	InputStream input=new FileInputStream(file);	
	int nread;
  byte[] buffer=new byte[4096];
  while((nread=input.read(buffer))>0)
    output.write(buffer,0,nread);
  socket_dest.close();	
	}  //try
	catch (Exception ecc)    			   	
	  {Server.log(toString()+", cannot deliver file"); 	}
	}		
protected	void sendFile(Socket socket_sorg)
	{
	Socket socket_dest;
	try{
	socket_dest=new Socket(host_dest.address,host_dest.port); 
	//socket_dest.setSoTimeout(20000);
	OutputStream output=socket_dest.getOutputStream();
	InputStream input=socket_sorg.getInputStream();	
	int nread;
  byte[] buffer=new byte[4096];
  while((nread=input.read(buffer))>0)
    output.write(buffer,0,nread);
  socket_sorg.close();
  socket_dest.close();	
	}  //try
	catch (Exception ecc)    			   	
	  {Server.log(toString()+", cannot deliver file");
	  try{socket_sorg.close();} catch(Exception ecc2){}
	  }
	}		


public String toString()
	{return getName()+" serving neighbour "+da_chi;}




}