import java.io.*;
import java.net.*;
	

class DuplicateKeyException extends Exception{
public DuplicateKeyException()
	{super("key already present in database");}
}		


class Host implements Serializable{
public InetAddress address;
public int port;
public Host(InetAddress ip,int port)
	{address=ip;
	this.port=port;
	}
public String toString()
	{return address+":"+port;}
}			






class WantedEntry {
public String id;
public int cont;
public ServerSocket wait_socket;
public WantedEntry(String id,int cont,ServerSocket wait_socket)
  {
  this.id=id;
  this.wait_socket=wait_socket;
  this.cont=cont;
  }
}

public class WantedTable extends java.util.Vector {
protected String archive_dir;
public WantedTable(String archive_dir) 
  {this.archive_dir=archive_dir;}
public String getArchiveDir()
  {return archive_dir;}


public synchronized void addEntry(String nomefile, int cont,ServerSocket wait_socket)
throws DuplicateKeyException	
	{	int i;
	  WantedEntry temp;
	  for (i=0; i<size(); i++) 
		 { temp=(WantedEntry)elementAt(i);
		   if (temp.id.equals(nomefile)) 
          throw new DuplicateKeyException();  //esce
     }
	addElement(new WantedEntry( nomefile, cont,wait_socket));
	}
		

public synchronized void fileFound(String nomefile)
		{ int i;
	  WantedEntry temp;
	  for (i=0; i<size(); i++) 
		 { temp=(WantedEntry)elementAt(i);
		   if (temp.id.equals(nomefile)) 
		 	   {
		  	 removeElementAt(i); 
		  	 return;
		 	   } //if
		 } //for		  	
	 }
	

public synchronized void fileNotFound(String nomefile)
		{ int i;
	  WantedEntry temp;
	  for (i=0; i<size(); i++) 
		 { temp=(WantedEntry)elementAt(i);
		   if (temp.id.equals(nomefile)) 
		  	 if(temp.cont==1) 
		  	 	  {removeElementAt(i);
		  	 	  try{ temp.wait_socket.close();} //sblocca la accept con un'eccz
		  	 	  catch(Exception ecc)	{}
		  	 	  }  //if	                    
		  	 else temp.cont--;  
		 }  //for
		
	}	
	
	

public String toString()
	{int i,size;
	size=size();
	String s="  This server is in search of "+size+" files";
	for(i=0;i<size;i++)
		s+="\n  ["+i+"] "+((WantedEntry)elementAt(i)).id+
			 " by "+((WantedEntry)elementAt(i)).cont+" other sites";
	return s;		       	
	}




}